Сообщить об ошибках

Автоматическое сообщение об ошибках

Вы можете отправить сообщение об ошибке из облачной функции в отчет об ошибках , как показано ниже:

Node.js

// These WILL be reported to Error Reporting
throw new Error('I failed you'); // Will cause a cold start if not caught

Питон

@functions_framework.http
def hello_error_1(request):
    # This WILL be reported to Error Reporting,
    # and WILL NOT show up in logs or
    # terminate the function.
    from google.cloud import error_reporting

    client = error_reporting.Client()

    try:
        raise RuntimeError("I failed you")
    except RuntimeError:
        client.report_exception()

    # This WILL be reported to Error Reporting,
    # and WILL terminate the function
    raise RuntimeError("I failed you")


@functions_framework.http
def hello_error_2(request):
    # These errors WILL NOT be reported to Error
    # Reporting, but will show up in logs.
    import logging
    import sys

    print(RuntimeError("I failed you (print to stdout)"))
    logging.warning(RuntimeError("I failed you (logging.warning)"))
    logging.error(RuntimeError("I failed you (logging.error)"))
    sys.stderr.write("I failed you (sys.stderr.write)\n")

    # This is considered a successful execution and WILL NOT be reported
    # to Error Reporting, but the status code (500) WILL be logged.
    from flask import abort

    return abort(500)

Если вам нужны более подробные отчеты об ошибках, вы можете использовать клиентские библиотеки отчетов об ошибках .

Вы можете просмотреть сообщения об ошибках в отчетах об ошибках в консоли GCP. Вы также можете просмотреть ошибки, о которых сообщает конкретная функция, выбрав ее из списка функций в консоли GCP.

Неперехваченные исключения, созданные вашей функцией, появятся в отчетах об ошибках. Обратите внимание, что некоторые типы неперехваченных исключений (например, возникающие асинхронно) приводят к холодному старту при будущем вызове функции. Это увеличивает время выполнения вашей функции.

Ручное сообщение об ошибках

Отправка в облачную регистрацию

Функция error из SDK Cloud Functions logger будет сообщать об ошибках как в Cloud Logging, так и в Error Reporting . Чтобы включить больше контекста ошибки в виде структурированных данных , передайте объект ошибки в качестве второго аргумента:

} catch (err) {
  // Attach an error object as the second argument
  functions.logger.error(
    "Unable to read quote from Firestore, sending default instead",
    err
  );
}